class
	PROJECT_SETTINGS

inherit
	ANY
		redefine
			default_create
		end

create
	default_create

feature {NONE}

	default_create
		do
			libraries := create {TWO_WAY_LIST [STRING_8]}.make
			include_dirs := create {TWO_WAY_LIST [STRING_8]}.make
		end

feature {ANY}

	cil_file: RAW_FILE assign set_cil_file

	set_cil_file (a_cil_file: RAW_FILE)
		require
			a_cil_file /= Void and then a_cil_file.exists
		do
			cil_file := a_cil_file
		end

	output_dir: DIRECTORY assign set_output_dir

	set_output_dir (a_output_dir: DIRECTORY)
		require
			a_output_dir /= Void and then a_output_dir.exists
		do
			output_dir := a_output_dir
		end

	libraries: LIST [STRING_8]

	include_dirs: LIST [STRING_8]

	disable_oo_structs: BOOLEAN assign set_disable_oo_structs

	set_disable_oo_structs (a_set_disable_oo_structs: BOOLEAN)
		do
			-- Adapt `CE_CLASS_POINTER' when set to `True'!
			disable_oo_structs := a_set_disable_oo_structs
		end

	disable_oo_reengineering: BOOLEAN assign set_disable_oo_reengineering

	set_disable_oo_reengineering (a_disable_oo_reengineering: BOOLEAN)
		do
			disable_oo_reengineering := a_disable_oo_reengineering
		end

	is_multithreaded: BOOLEAN assign set_is_multithreaded

	set_is_multithreaded (a_is_multithreaded: BOOLEAN)
		do
			is_multithreaded := a_is_multithreaded
		end

	disable_bounds_checking: BOOLEAN assign set_disable_bounds_checking

	set_disable_bounds_checking (a_disable_bounds_checking: BOOLEAN)
		do
			disable_bounds_checking := a_disable_bounds_checking
		end

feature {ANY} -- set if started in wizard mode

	wizard_file: STRING_8 assign set_wizard_file

	set_wizard_file (a_wizard_file: STRING_8)
		do
			wizard_file := a_wizard_file
		end

invariant
	libraries /= Void
	include_dirs /= Void

end
