class
	ANTLR_AST_NODE

create
	make

feature {NONE}

	make (a_antlr_c_node: POINTER)
		require
			a_antlr_c_node /= default_pointer
		do
			antlr_c_node := a_antlr_c_node
		ensure
			antlr_c_node = a_antlr_c_node
		end

feature {ANY}

	type: INTEGER
		once ("OBJECT")
			Result := c_get_type (antlr_c_node)
		end

	token_text: STRING
		once ("OBJECT")
			Result := c_get_token_text (antlr_c_node)
		end

	children: LIST [ANTLR_AST_NODE]
		local
			i, count: INTEGER
		once ("OBJECT")
			from
				i := 1
				count := c_get_child_count (antlr_c_node)
				Result := create {ARRAYED_LIST [ANTLR_AST_NODE]}.make (count)
			until
				i > count
			loop
				Result.extend (create {ANTLR_AST_NODE}.make (c_get_child (antlr_c_node, i - 1)))
				i := i + 1
			end
		end

feature {SOURCE_LOADER}

	antlr_c_node: POINTER

feature {NONE}

	c_get_type (a_antlr_c_node: POINTER): INTEGER
		external
			"C inline use <antlr3.h>"
		alias
			"[
				pANTLR3_BASE_TREE node = $a_antlr_c_node;
				return node->getType(node);
			]"
		end

	c_get_token_text (a_antlr_c_node: POINTER): STRING
		external
			"C inline use <antlr3.h>"
		alias
			"[
				pANTLR3_BASE_TREE node = $a_antlr_c_node;
				pANTLR3_COMMON_TOKEN token = node->getToken(node);
				return eif_string((token->getText(token) != NULL) ? (char *)token->getText(token)->chars : (char *)token->tokText.chars);
			]"
		end

	c_get_child_count (a_antlr_c_node: POINTER): INTEGER
		external
			"C inline use <antlr3.h>"
		alias
			"[
				pANTLR3_BASE_TREE node = $a_antlr_c_node;
				return node->getChildCount(node);
			]"
		end

	c_get_child (a_antlr_c_node: POINTER; i: INTEGER): POINTER
		external
			"C inline use <antlr3.h>"
		alias
			"[
				pANTLR3_BASE_TREE node = $a_antlr_c_node;
				return node->getChild(node, $i);
			]"
		end

invariant
	antlr_c_node /= default_pointer

end
