class
	AST_EXPRESSION_STATEMENT

inherit
	AST_STATEMENT

create
	default_create,
	make,
	make_from_antlr,
	make_copy

feature {NONE}

	make (a_expression: AST_EXPRESSION)
		require
			a_expression /= Void implies a_expression.parent = Void
		do
			if a_expression /= Void then
				expression := a_expression
				expression.parent := Current
			end
		end

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = Ast_expression_statement
		do
			parent := init_parent
			if node.children.count = 2 then
				expression := process_expression (node.children.first, Current)
			end
		end

feature {ANY}

	expression: AST_EXPRESSION

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_expression_statement (Current)
			if visit_children then
				visit_node (expression, v)
			end
			v.end_visit_expression_statement (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			if other.expression /= Void then
				expression := other.expression.ast_twin
				expression.parent := Current
			end
		end

end
