class
	AST_LABELED_STATEMENT

inherit
	AST_STATEMENT

create
	make_from_antlr,
	make_copy

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = Ast_labeled_statement
		do
			parent := init_parent
			node.children.start
			identifier := node.children.item.token_text
			node.children.forth
			statement := process_statement (node.children.item, Current)
		end

feature {ANY}

	identifier: STRING

	statement: AST_STATEMENT assign set_statement

	set_statement (a_statement: AST_STATEMENT)
		require
			a_statement /= Void and then a_statement.parent = Void
		do
			statement.parent := Void
			statement := a_statement
			statement.parent := Current
		ensure
			statement = a_statement
			statement.parent = Current
		end

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_labeled_statement (Current)
			if visit_children then
				visit_node (statement, v)
			end
			v.end_visit_labeled_statement (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			identifier := other.identifier.twin
			statement := other.statement.ast_twin
			statement.parent := Current
		end

invariant
	identifier /= Void and then not identifier.is_empty
	statement /= Void

end
