class
	AST_EIFFEL_TYPE

inherit
	AST_TYPE
		redefine
			make_copy
		end

create
	make,
	make_copy

feature {NONE} -- Initialization

	make (a_type_name: STRING)
		require
			a_type_name /= Void and then not a_type_name.is_empty
		do
			type_name := a_type_name
		end

feature {ANY}

	type_name: STRING

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_eiffel_type (Current)
			if visit_children then
				-- no children
			end
			v.end_visit_eiffel_type (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

feature {ANY} -- AST_TYPE

	is_equal_type (a_type: AST_TYPE): BOOLEAN
		do
			if
				attached {AST_EIFFEL_TYPE} a_type as eiffel_type and then
				type_name.is_equal (eiffel_type.type_name)
			then
				Result := True
			end
		end

	make_copy (other: like Current)
		do
			type_name := other.type_name
		end

invariant
	type_name /= Void and then not type_name.is_empty

end
