class
	AST_ENUM_TYPE

inherit
	AST_TYPE
		redefine
			make_copy
		end
	BINDINGS_STATUS

create
	make_from_antlr,
	make_copy

feature {NONE}

	make_from_antlr (node: ANTLR_AST_NODE; init_parent: AST_NODE)
		require
			node /= Void and then node.type = C_kw_enum
		do
			parent := init_parent
			identifier := node.children.first.token_text
		end

feature {ANY}

	identifier: STRING

	declaration_binding: AST_ENUM_DECLARATION assign set_declaration_binding

	set_declaration_binding (a_declaration_binding: AST_ENUM_DECLARATION)
		require
			a_declaration_binding /= Void
		do
			declaration_binding := a_declaration_binding
		end

feature {ANY} -- AST_NODE

	accept (v: AST_VISITOR)
		local
			visit_children: BOOLEAN
		do
			v.pre_visit (Current)
			visit_children := v.visit_enum_type (Current)
			if visit_children then
				-- no children
			end
			v.end_visit_enum_type (Current)
			v.post_visit (Current)
		end

	ast_twin: like Current
		do
			create Result.make_copy (Current)
		end

	make_copy (other: like Current)
		do
			Precursor (other)
			identifier := other.identifier.twin
			declaration_binding := other.declaration_binding
		end

feature {ANY} -- AST_TYPE

	is_equal_type (a_type: AST_TYPE): BOOLEAN
		do
			if attached {AST_ENUM_TYPE} a_type as other_type then
				Result := identifier.is_equal (other_type.identifier)
			end
		end


invariant
	identifier /= Void and then not identifier.is_empty
	Bindings_active.item implies declaration_binding /= Void

end
