class
	HASH_SET [G -> HASHABLE]

inherit
	ITERABLE [G]

create
	make

feature {NONE}

	make (n: INTEGER)
		do
			create hash_table.make (n)
		end

feature {HASH_SET_ITERATION_CURSOR}

	hash_table: HASH_TABLE [ANY, G]

feature {ANY}

	extend (a_item: G)
		require
			a_item /= Void
		do
			if not has (a_item) then
				hash_table.extend (Void, a_item)
			end
		end

	has (a_item: G): BOOLEAN
		require
			a_item /= Void
		do
			Result := hash_table.has (a_item)
		end

	is_empty: BOOLEAN
		do
			Result := hash_table.is_empty
		end

	wipe_out
		do
			hash_table.wipe_out
		end

	linear_representation: ARRAYED_LIST [G]
		do
			create Result.make (hash_table.count)
			across hash_table as c loop
				Result.extend (c.key)
			end
		end

	count: INTEGER_32
		do
			Result := hash_table.count
		end

	remove (a_item: G)
		require
			a_item /= Void
		do
			hash_table.remove (a_item)
		end

feature {ANY}

	new_cursor: HASH_SET_ITERATION_CURSOR [G]
		do
			create Result.make (Current)
			Result.start
		end

invariant
	hash_table /= Void

end
