class
	BUILTIN_TRANSFORMER

inherit
	TRANSFORMATION_STEP
	AST_DEFAULT_VISITOR
		redefine
			end_visit_function_declaration,
			end_visit_function_call
		end
	AST_UTILITIES

feature {ANY} -- TRANSFORMATION_STEP

	process_impl: BOOLEAN
		do
			transformer.tree.accept (Current)
			Result := True
		end

	description: STRING
		do
			Result := "Transforming built-in GCC functions if necessary"
		end

feature {ANY} -- AST_DEFAULT_VISITOR

	end_visit_function_declaration (node: AST_FUNCTION_DECLARATION)
		do
			if node.orig_c_identifier.is_equal ("__builtin_prefetch") then
				delete_node (node)
			end
		end

	end_visit_function_call (node: AST_FUNCTION_CALL)
		do
			if
				attached node.identifier_str as identifier and then
				identifier.is_equal ("__builtin_prefetch") and then
				attached {AST_EXPRESSION_STATEMENT} node.parent as es
			then
				delete_node (es)
				-- TODO: keep expressions with side effects
			end
		end

end
