class
	CALL_GRAPH_CREATOR

inherit
	TRANSFORMATION_STEP
	AST_DEFAULT_VISITOR
		redefine
			end_visit_function_call,
			end_visit_variable_expression
		end

feature {ANY} -- TRANSFORMATION_STEP

	process_impl: BOOLEAN
		do
			across transformer.tree.declarations as c loop
				if attached {AST_EIFFEL_FEATURE} c.item as ef then
					ef.call_graph := create {CALL_GRAPH_NODE}.make (ef)
				end
			end

			across transformer.tree.declarations as c loop
				if attached {AST_EIFFEL_FEATURE} c.item as ef then
					calling_feature := ef
					ef.accept (Current)
				end
			end
			calling_feature := Void

			Result := True
		end

	description: STRING
		do
			Result := "Creating the call graph"
		end

feature {NONE}

	calling_feature: AST_EIFFEL_FEATURE

feature {NONE}

	end_visit_function_call (a_node: AST_FUNCTION_CALL)
		do
			if
				attached {AST_FUNCTION_DECLARATION} a_node.declaration_binding as called_func and then
				calling_feature /= called_func
			then
				calling_feature.call_graph.add_out_call (called_func.call_graph)
			end
		end

	end_visit_variable_expression (a_node: AST_VARIABLE_EXPRESSION)
		do
			if
				attached {AST_VARIABLE_DECLARATION} a_node.declaration_binding as called_var and then
				attached {AST_TRANSLATION_UNIT} called_var.parent and then
				calling_feature /= called_var
			then
				calling_feature.call_graph.add_out_call (called_var.call_graph)
			end
		end

end
